//  *****************************************************************************
//   						main.c
// 
//              Demonstracny program pre dosku KTK ARM7
//
//              Stlacanim tlacidla S2 sa striedavo zapina a vypina LED
//
//  *****************************************************************************

// Hlavickove subory
#include "board.h"


//  *******************************************************
//  Kratke cakanie (cca 450 us)
//  *******************************************************
void cakaj(void)
{ unsigned int cas;
 
  for(cas=0; cas < MCK/20000; cas++);
}

//  *******************************************************
//                Hlavny program
//  *******************************************************
int main(void) 
{
  //******************* Uvodna inicializacia *******************

  // Povolenie Resetu - minimalna dlzka 960 us
  AT91C_BASE_RSTC->RSTC_RMR = AT91C_RSTC_URSTEN | (0x4<<8) | (unsigned int)(0xA5<<24);
	
  //******************* Inicializacia portu A ******************

  // Povolenie hodin pre PIOA
  AT91C_BASE_PMC->PMC_PCER = (unsigned int) 1 << AT91C_ID_PIOA; 
	
  // konfiguracia jednotlivych pinov
  // vstupne piny
  AT91C_BASE_PIOA->PIO_ODR = S2;
  // vystupne piny
  AT91C_BASE_PIOA->PIO_OER = D1;
  // povolenie Pull-Up rezistoru
  AT91C_BASE_PIOA->PIO_PPUER = S2;
  // povolenie vsetkych nakonfigurovanych pinov
  AT91C_BASE_PIOA->PIO_PER = D1 | S2;

  //******************* Hlavna cast programu *******************

  // zapnutie LED - bola ukoncena inicializacia
  AT91C_BASE_PIOA->PIO_SODR = D1;

  // nekonecna slucka
  while(1)
  { // cakanie na stlacenie S2  
    while(AT91C_BASE_PIOA->PIO_PDSR & S2)     // kontrola, ci je S2 v log.1
      cakaj();                                // cakanie kvoli potlaceniu zakmitov
    // cakanie na pustenie S2
    while(!(AT91C_BASE_PIOA->PIO_PDSR & S2))  // kontrola, ci je S2 v log.0
      cakaj();                                // cakanie kvoli potlaceniu zakmitov

    // prepnutie LED diody
    if (AT91C_BASE_PIOA->PIO_PDSR & D1)
    { AT91C_BASE_PIOA->PIO_CODR = D1;	      // vypnutie LED
    }
    else
    { AT91C_BASE_PIOA->PIO_SODR = D1;	      // zapnutie LED
    }
  }
}
